<html>
<head>
<title>OGRE: OgrePrerequisites.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgrePrerequisites.h</h1><a href="OgrePrerequisites_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*-------------------------------------------------------------------------</span>
<a name="l00002"></a>00002 <span class="comment">This source file is a part of OGRE</span>
<a name="l00003"></a>00003 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This library is free software; you can redistribute it and/or modify it</span>
<a name="l00011"></a>00011 <span class="comment">under the terms of the GNU Lesser General Public License (LGPL) as</span>
<a name="l00012"></a>00012 <span class="comment">published by the Free Software Foundation; either version 2.1 of the</span>
<a name="l00013"></a>00013 <span class="comment">License, or (at your option) any later version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This library is distributed in the hope that it will be useful, but</span>
<a name="l00016"></a>00016 <span class="comment">WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY</span>
<a name="l00017"></a>00017 <span class="comment">or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">License for more details.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">You should have received a copy of the GNU Lesser General Public License</span>
<a name="l00021"></a>00021 <span class="comment">along with this library; if not, write to the Free Software Foundation,</span>
<a name="l00022"></a>00022 <span class="comment">Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA or go to</span>
<a name="l00023"></a>00023 <span class="comment">http://www.gnu.org/copyleft/lesser.txt</span>
<a name="l00024"></a>00024 <span class="comment">-------------------------------------------------------------------------*/</span>
<a name="l00025"></a>00025 <span class="preprocessor">#ifndef __OgrePrerequisites_H__</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span><span class="preprocessor">#define __OgrePrerequisites_H__</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="comment">// undefine this to not require new angular units where applicable</span>
<a name="l00029"></a><a class="code" href="OgrePrerequisites_8h.html#7421389cf556413d74682c7e8edf9220">00029</a> <span class="preprocessor">#define OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Platform-specific stuff</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePlatform_8h.html">OgrePlatform.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_MSVC</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="comment">// Turn off warnings generated by long std templates</span>
<a name="l00036"></a>00036 <span class="comment">// This warns about truncation to 255 characters in debug/browse info</span>
<a name="l00037"></a>00037 <span class="preprocessor">#   pragma warning (disable : 4786)</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="comment">// Turn off warnings generated by long std templates</span>
<a name="l00040"></a>00040 <span class="comment">// This warns about truncation to 255 characters in debug/browse info</span>
<a name="l00041"></a>00041 <span class="preprocessor">#   pragma warning (disable : 4503)</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="comment">// disable: "conversion from 'double' to 'float', possible loss of data</span>
<a name="l00044"></a>00044 <span class="preprocessor">#   pragma warning (disable : 4244)</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>
<a name="l00046"></a>00046 <span class="comment">// disable: "truncation from 'double' to 'float'</span>
<a name="l00047"></a>00047 <span class="preprocessor">#   pragma warning (disable : 4305)</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>
<a name="l00049"></a>00049 <span class="comment">// disable: "&lt;type&gt; needs to have dll-interface to be used by clients'</span>
<a name="l00050"></a>00050 <span class="comment">// Happens on STL member variables which are not public therefore is ok</span>
<a name="l00051"></a>00051 <span class="preprocessor">#   pragma warning (disable : 4251)</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>
<a name="l00053"></a>00053 <span class="comment">// disable: "non dll-interface class used as base for dll-interface class"</span>
<a name="l00054"></a>00054 <span class="comment">// Happens when deriving from Singleton because bug in compiler ignores</span>
<a name="l00055"></a>00055 <span class="comment">// template export</span>
<a name="l00056"></a>00056 <span class="preprocessor">#   pragma warning (disable : 4275)</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058 <span class="comment">// disable: "C++ Exception Specification ignored"</span>
<a name="l00059"></a>00059 <span class="comment">// This is because MSVC 6 did not implement all the C++ exception</span>
<a name="l00060"></a>00060 <span class="comment">// specifications in the ANSI C++ draft.</span>
<a name="l00061"></a>00061 <span class="preprocessor">#   pragma warning( disable : 4290 )</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>
<a name="l00063"></a>00063 <span class="comment">// disable: "no suitable definition provided for explicit template</span>
<a name="l00064"></a>00064 <span class="comment">// instantiation request" Occurs in VC7 for no justifiable reason on all</span>
<a name="l00065"></a>00065 <span class="comment">// #includes of Singleton</span>
<a name="l00066"></a>00066 <span class="preprocessor">#   pragma warning( disable: 4661)</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068 <span class="comment">// disable: deprecation warnings when using CRT calls in VC8</span>
<a name="l00069"></a>00069 <span class="comment">// These show up on all C runtime lib code in VC8, disable since they clutter</span>
<a name="l00070"></a>00070 <span class="comment">// the warnings with things we may not be able to do anything about (e.g.</span>
<a name="l00071"></a>00071 <span class="comment">// generated code from nvparse etc). I doubt very much that these calls</span>
<a name="l00072"></a>00072 <span class="comment">// will ever be actually removed from VC anyway, it would break too much code.</span>
<a name="l00073"></a>00073 <span class="preprocessor">#   pragma warning( disable: 4996)</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>
<a name="l00075"></a>00075 <span class="comment">// disable: "conditional expression constant", always occurs on </span>
<a name="l00076"></a>00076 <span class="comment">// OGRE_MUTEX_CONDITIONAL when no threading enabled</span>
<a name="l00077"></a>00077 <span class="preprocessor">#   pragma warning (disable : 201)</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>
<a name="l00079"></a>00079 <span class="preprocessor">#endif</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>
<a name="l00081"></a>00081 <span class="comment">/* Include all the standard header *after* all the configuration</span>
<a name="l00082"></a>00082 <span class="comment">   settings have been made.</span>
<a name="l00083"></a>00083 <span class="comment">*/</span>
<a name="l00084"></a>00084 <span class="comment">//#include "OgreStdHeaders.h"</span>
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="preprocessor">#include "<a class="code" href="OgreMemoryManager_8h.html">OgreMemoryManager.h</a>"</span>
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="keyword">namespace </span>Ogre {
<a name="l00090"></a>00090     <span class="comment">// Define ogre version</span>
<a name="l00091"></a><a class="code" href="OgrePrerequisites_8h.html#e5b524dcaad06fe829b6a1952cc6f7cf">00091</a> <span class="preprocessor">    #define OGRE_VERSION_MAJOR 1</span>
<a name="l00092"></a><a class="code" href="OgrePrerequisites_8h.html#151f60246acece3e651a8f1d0999f85b">00092</a> <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_VERSION_MINOR 4</span>
<a name="l00093"></a><a class="code" href="OgrePrerequisites_8h.html#144780d2bcdd852d2ff7a7a450c7856d">00093</a> <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_VERSION_PATCH 9</span>
<a name="l00094"></a><a class="code" href="OgrePrerequisites_8h.html#bce1e968a0f7309c73a8a2d7a19544e2">00094</a> <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_VERSION_SUFFIX ""</span>
<a name="l00095"></a><a class="code" href="OgrePrerequisites_8h.html#4a5177c0cfa26a662edfe3e311935fdf">00095</a> <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_VERSION_NAME "Eihort"</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span>
<a name="l00097"></a><a class="code" href="OgrePrerequisites_8h.html#3f631403da0a255c201870bfd068f8c5">00097</a> <span class="preprocessor">    #define OGRE_VERSION    ((OGRE_VERSION_MAJOR &lt;&lt; 16) | (OGRE_VERSION_MINOR &lt;&lt; 8) | OGRE_VERSION_PATCH)</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>
<a name="l00099"></a>00099     <span class="comment">// define the real number values to be used</span>
<a name="l00100"></a>00100     <span class="comment">// default to use 'float' unless precompiler option set</span>
<a name="l00101"></a>00101 <span class="preprocessor">    #if OGRE_DOUBLE_PRECISION == 1</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span>
<a name="l00105"></a>00105         <span class="keyword">typedef</span> <span class="keywordtype">double</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>;
<a name="l00106"></a>00106 <span class="preprocessor">    #else</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span>
<a name="l00110"></a><a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">00110</a>         <span class="keyword">typedef</span> <span class="keywordtype">float</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>;
<a name="l00111"></a>00111 <span class="preprocessor">    #endif</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
<a name="l00113"></a>00113 <span class="preprocessor">    #if OGRE_COMPILER == OGRE_COMPILER_GNUC &amp;&amp; OGRE_COMP_VER &gt;= 310 &amp;&amp; !defined(STLPORT)</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span><span class="preprocessor">    #   define HashMap ::__gnu_cxx::hash_map</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span><span class="preprocessor">    #else</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span><span class="preprocessor">    #   if OGRE_COMPILER == OGRE_COMPILER_MSVC</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span><span class="preprocessor">    #       if OGRE_COMP_VER &gt; 1300 &amp;&amp; !defined(_STLP_MSVC)</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span><span class="preprocessor">    #           define HashMap ::stdext::hash_map</span>
<a name="l00119"></a>00119 <span class="preprocessor"></span><span class="preprocessor">    #       else</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span><span class="preprocessor">    #           define HashMap ::std::hash_map</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span><span class="preprocessor">    #       endif</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span><span class="preprocessor">    #   else</span>
<a name="l00123"></a><a class="code" href="OgrePrerequisites_8h.html#a3cf5d1d0401f71e90c8684179eb9bf2">00123</a> <span class="preprocessor"></span><span class="preprocessor">    #       define HashMap ::std::hash_map</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span><span class="preprocessor">    #   endif</span>
<a name="l00125"></a>00125 <span class="preprocessor"></span><span class="preprocessor">    #endif</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>
<a name="l00129"></a><a class="code" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">00129</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :).">uchar</a>;
<a name="l00130"></a><a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">00130</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>;
<a name="l00131"></a><a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">00131</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a>;
<a name="l00132"></a><a class="code" href="namespaceOgre.html#4304981347643708ee9a7ba8884e5758">00132</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="namespaceOgre.html#4304981347643708ee9a7ba8884e5758">ulong</a>;
<a name="l00133"></a>00133 
<a name="l00135"></a><a class="code" href="OgrePrerequisites_8h.html#d0131329b1343dd9a058b14e3f44aac9">00135</a> <span class="preprocessor">    #define OGRE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }</span>
<a name="l00136"></a><a class="code" href="OgrePrerequisites_8h.html#d613054ae26b7fa1a7b90816c3048192">00136</a> <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>
<a name="l00138"></a>00138 <span class="preprocessor">    #if OGRE_WCHAR_T_STRINGS</span>
<a name="l00139"></a>00139 <span class="preprocessor"></span>        <span class="keyword">typedef</span> std::wstring <a class="code" href="namespaceOgre.html#6190e7c0a19190277aeadf25f536ac8c">_StringBase</a>;
<a name="l00140"></a>00140 <span class="preprocessor">    #else</span>
<a name="l00141"></a><a class="code" href="namespaceOgre.html#6190e7c0a19190277aeadf25f536ac8c">00141</a> <span class="preprocessor"></span>        <span class="keyword">typedef</span> std::string <a class="code" href="namespaceOgre.html#6190e7c0a19190277aeadf25f536ac8c">_StringBase</a>;
<a name="l00142"></a>00142 <span class="preprocessor">    #endif</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>
<a name="l00144"></a><a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">00144</a>     <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#6190e7c0a19190277aeadf25f536ac8c">_StringBase</a> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     <span class="comment">// Useful threading defines</span>
<a name="l00147"></a><a class="code" href="OgrePrerequisites_8h.html#b5230fc97085f9d074db2e47a4fd93d4">00147</a> <span class="preprocessor">    #define OGRE_AUTO_MUTEX_NAME mutex</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span><span class="preprocessor">    #if OGRE_THREAD_SUPPORT</span>
<a name="l00149"></a>00149 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_AUTO_MUTEX mutable boost::recursive_mutex OGRE_AUTO_MUTEX_NAME;</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_LOCK_AUTO_MUTEX boost::recursive_mutex::scoped_lock ogreAutoMutexLock(OGRE_AUTO_MUTEX_NAME);</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_MUTEX(name) mutable boost::recursive_mutex name;</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_STATIC_MUTEX(name) static boost::recursive_mutex name;</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_STATIC_MUTEX_INSTANCE(name) boost::recursive_mutex name;</span>
<a name="l00154"></a>00154 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_LOCK_MUTEX(name) boost::recursive_mutex::scoped_lock ogrenameLock(name);</span>
<a name="l00155"></a>00155 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_LOCK_MUTEX_NAMED(mutexName, lockName) boost::recursive_mutex::scoped_lock lockName(mutexName);</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>        <span class="comment">// like OGRE_AUTO_MUTEX but mutex held by pointer</span>
<a name="l00157"></a>00157 <span class="preprocessor">        #define OGRE_AUTO_SHARED_MUTEX mutable boost::recursive_mutex *OGRE_AUTO_MUTEX_NAME;</span>
<a name="l00158"></a>00158 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_LOCK_AUTO_SHARED_MUTEX assert(OGRE_AUTO_MUTEX_NAME); boost::recursive_mutex::scoped_lock ogreAutoMutexLock(*OGRE_AUTO_MUTEX_NAME);</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_NEW_AUTO_SHARED_MUTEX assert(!OGRE_AUTO_MUTEX_NAME); OGRE_AUTO_MUTEX_NAME = new boost::recursive_mutex();</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_DELETE_AUTO_SHARED_MUTEX assert(OGRE_AUTO_MUTEX_NAME); delete OGRE_AUTO_MUTEX_NAME;</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_COPY_AUTO_SHARED_MUTEX(from) assert(!OGRE_AUTO_MUTEX_NAME); OGRE_AUTO_MUTEX_NAME = from;</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_SET_AUTO_SHARED_MUTEX_NULL OGRE_AUTO_MUTEX_NAME = 0;</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_MUTEX_CONDITIONAL(mutex) if (mutex)</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_SYNCHRONISER(sync) boost::condition sync;</span>
<a name="l00165"></a>00165 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_WAIT(sync, lock) sync.wait(lock);</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_NOTIFY_ONE(sync) sync.notify_one(); </span>
<a name="l00167"></a>00167 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_NOTIFY_ALL(sync) sync.notify_all(); </span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>        <span class="comment">// Thread-local pointer</span>
<a name="l00169"></a>00169 <span class="preprocessor">        #define OGRE_THREAD_POINTER(T, var) boost::thread_specific_ptr&lt;T&gt; var</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_POINTER_SET(var, expr) var.reset(expr)</span>
<a name="l00171"></a>00171 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_POINTER_DELETE(var) var.reset(0)</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_POINTER_GET(var) var.get()</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span><span class="preprocessor">    #else</span>
<a name="l00174"></a><a class="code" href="OgrePrerequisites_8h.html#18a523fad1f9e10324e1742865f562b7">00174</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_AUTO_MUTEX</span>
<a name="l00175"></a><a class="code" href="OgrePrerequisites_8h.html#ce4a3180018d84c5295b17251233abfb">00175</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_LOCK_AUTO_MUTEX</span>
<a name="l00176"></a><a class="code" href="OgrePrerequisites_8h.html#2fb96ea8ad9700f804480d1d7f5d692d">00176</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_MUTEX(name)</span>
<a name="l00177"></a><a class="code" href="OgrePrerequisites_8h.html#c853de57688aefaec88f75cd9e0ac388">00177</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_STATIC_MUTEX(name)</span>
<a name="l00178"></a><a class="code" href="OgrePrerequisites_8h.html#042f108091bba675307acb915a71bfa9">00178</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_STATIC_MUTEX_INSTANCE(name)</span>
<a name="l00179"></a><a class="code" href="OgrePrerequisites_8h.html#8a4683cdaf73994ea7ec391c1ba82b60">00179</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_LOCK_MUTEX(name)</span>
<a name="l00180"></a><a class="code" href="OgrePrerequisites_8h.html#39e611f7baf80408d740fce6a2502414">00180</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_LOCK_MUTEX_NAMED(mutexName, lockName)</span>
<a name="l00181"></a><a class="code" href="OgrePrerequisites_8h.html#b0e8c6d123555d7447c38185a1b9105e">00181</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_AUTO_SHARED_MUTEX</span>
<a name="l00182"></a><a class="code" href="OgrePrerequisites_8h.html#062b6df8793a5440c06a9056ff1c8fe9">00182</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_LOCK_AUTO_SHARED_MUTEX</span>
<a name="l00183"></a><a class="code" href="OgrePrerequisites_8h.html#9ea1b6f845efd15c581b914ac84b93a3">00183</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_NEW_AUTO_SHARED_MUTEX</span>
<a name="l00184"></a><a class="code" href="OgrePrerequisites_8h.html#8b873e0e48fc343f9553e1dc526ff6f3">00184</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_DELETE_AUTO_SHARED_MUTEX</span>
<a name="l00185"></a><a class="code" href="OgrePrerequisites_8h.html#cf02af48b9d015cd2f0c10e22466c73a">00185</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_COPY_AUTO_SHARED_MUTEX(from)</span>
<a name="l00186"></a><a class="code" href="OgrePrerequisites_8h.html#053475f75a35e320fa019cf083ba8918">00186</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_SET_AUTO_SHARED_MUTEX_NULL</span>
<a name="l00187"></a><a class="code" href="OgrePrerequisites_8h.html#2201eef4cf31a94b24d79de6de3445af">00187</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_MUTEX_CONDITIONAL(name) if(true)</span>
<a name="l00188"></a><a class="code" href="OgrePrerequisites_8h.html#792b8674a3579bf049e399dbfecf9f8b">00188</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_SYNCHRONISER(sync) </span>
<a name="l00189"></a><a class="code" href="OgrePrerequisites_8h.html#d5c607c0bb02c1a7c9f124768eade0bf">00189</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_WAIT(sync, lock) </span>
<a name="l00190"></a><a class="code" href="OgrePrerequisites_8h.html#f95a22a8a787bbf4956772d36a0ccab5">00190</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_NOTIFY_ONE(sync) </span>
<a name="l00191"></a><a class="code" href="OgrePrerequisites_8h.html#15a4eee729a2c973782b3d65262b6c33">00191</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_NOTIFY_ALL(sync) </span>
<a name="l00192"></a><a class="code" href="OgrePrerequisites_8h.html#7bbad1426a73ac69e63279b16e0f8ac4">00192</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_POINTER(T, var) T* var</span>
<a name="l00193"></a><a class="code" href="OgrePrerequisites_8h.html#b2cf92160e83b716119c42240aad670f">00193</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_POINTER_SET(var, expr) var = expr</span>
<a name="l00194"></a><a class="code" href="OgrePrerequisites_8h.html#9501d2980e624057c7701c0b3b539c3c">00194</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_POINTER_DELETE(var) delete var; var = 0</span>
<a name="l00195"></a><a class="code" href="OgrePrerequisites_8h.html#5a4c5f6a9667046f955529291276f3dd">00195</a> <span class="preprocessor"></span><span class="preprocessor">        #define OGRE_THREAD_POINTER_GET(var) var</span>
<a name="l00196"></a>00196 <span class="preprocessor"></span><span class="preprocessor">    #endif</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="comment">// Pre-declare classes</span>
<a name="l00200"></a>00200 <span class="comment">// Allows use of pointers in header files without including individual .h</span>
<a name="l00201"></a>00201 <span class="comment">// so decreases dependencies between files</span>
<a name="l00202"></a>00202     <span class="keyword">class </span>Angle;
<a name="l00203"></a>00203     <span class="keyword">class </span>Animation;
<a name="l00204"></a>00204     <span class="keyword">class </span>AnimationState;
<a name="l00205"></a>00205     <span class="keyword">class </span>AnimationStateSet;
<a name="l00206"></a>00206     <span class="keyword">class </span>AnimationTrack;
<a name="l00207"></a>00207     <span class="keyword">class </span>Archive;
<a name="l00208"></a>00208     <span class="keyword">class </span>ArchiveFactory;
<a name="l00209"></a>00209     <span class="keyword">class </span>ArchiveManager;
<a name="l00210"></a>00210     <span class="keyword">class </span>AutoParamDataSource;
<a name="l00211"></a>00211     <span class="keyword">class </span>AxisAlignedBox;
<a name="l00212"></a>00212     <span class="keyword">class </span>AxisAlignedBoxSceneQuery;
<a name="l00213"></a>00213     <span class="keyword">class </span>Billboard;
<a name="l00214"></a>00214     <span class="keyword">class </span>BillboardChain;
<a name="l00215"></a>00215     <span class="keyword">class </span>BillboardSet;
<a name="l00216"></a>00216     <span class="keyword">class </span>Bone;
<a name="l00217"></a>00217     <span class="keyword">class </span>Camera;
<a name="l00218"></a>00218     <span class="keyword">class </span>Codec;
<a name="l00219"></a>00219     <span class="keyword">class </span>ColourValue;
<a name="l00220"></a>00220     <span class="keyword">class </span>ConfigDialog;
<a name="l00221"></a>00221     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>Controller;
<a name="l00222"></a>00222     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>ControllerFunction;
<a name="l00223"></a>00223     <span class="keyword">class </span>ControllerManager;
<a name="l00224"></a>00224     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>ControllerValue;
<a name="l00225"></a>00225     <span class="keyword">class </span>Degree;
<a name="l00226"></a>00226     <span class="keyword">class </span>DynLib;
<a name="l00227"></a>00227     <span class="keyword">class </span>DynLibManager;
<a name="l00228"></a>00228     <span class="keyword">class </span>EdgeData;
<a name="l00229"></a>00229     <span class="keyword">class </span>EdgeListBuilder;
<a name="l00230"></a>00230     <span class="keyword">class </span>Entity;
<a name="l00231"></a>00231     <span class="keyword">class </span>ErrorDialog;
<a name="l00232"></a>00232     <span class="keyword">class </span>ExternalTextureSourceManager;
<a name="l00233"></a>00233     <span class="keyword">class </span>Factory;
<a name="l00234"></a>00234     <span class="keyword">class </span>Font;
<a name="l00235"></a>00235     <span class="keyword">class </span>FontPtr;
<a name="l00236"></a>00236     <span class="keyword">class </span>FontManager;
<a name="l00237"></a>00237     <span class="keyword">struct </span>FrameEvent;
<a name="l00238"></a>00238     <span class="keyword">class </span>FrameListener;
<a name="l00239"></a>00239     <span class="keyword">class </span>Frustum;
<a name="l00240"></a>00240     <span class="keyword">class </span>GpuProgram;
<a name="l00241"></a>00241     <span class="keyword">class </span>GpuProgramPtr;
<a name="l00242"></a>00242     <span class="keyword">class </span>GpuProgramManager;
<a name="l00243"></a>00243     <span class="keyword">class </span>GpuProgramUsage;
<a name="l00244"></a>00244     <span class="keyword">class </span>HardwareIndexBuffer;
<a name="l00245"></a>00245     <span class="keyword">class </span>HardwareOcclusionQuery;
<a name="l00246"></a>00246     <span class="keyword">class </span>HardwareVertexBuffer;
<a name="l00247"></a>00247     <span class="keyword">class </span>HardwarePixelBuffer;
<a name="l00248"></a>00248     <span class="keyword">class </span>HardwarePixelBufferSharedPtr;
<a name="l00249"></a>00249     <span class="keyword">class </span>HighLevelGpuProgram;
<a name="l00250"></a>00250     <span class="keyword">class </span>HighLevelGpuProgramPtr;
<a name="l00251"></a>00251     <span class="keyword">class </span>HighLevelGpuProgramManager;
<a name="l00252"></a>00252     <span class="keyword">class </span>HighLevelGpuProgramFactory;
<a name="l00253"></a>00253     <span class="keyword">class </span>IndexData;
<a name="l00254"></a>00254     <span class="keyword">class </span>IntersectionSceneQuery;
<a name="l00255"></a>00255     <span class="keyword">class </span>IntersectionSceneQueryListener;
<a name="l00256"></a>00256     <span class="keyword">class </span>Image;
<a name="l00257"></a>00257     <span class="keyword">class </span>KeyFrame;
<a name="l00258"></a>00258     <span class="keyword">class </span>Light;
<a name="l00259"></a>00259     <span class="keyword">class </span>Log;
<a name="l00260"></a>00260     <span class="keyword">class </span>LogManager;
<a name="l00261"></a>00261     <span class="keyword">class </span>ManualResourceLoader;
<a name="l00262"></a>00262     <span class="keyword">class </span>ManualObject;
<a name="l00263"></a>00263     <span class="keyword">class </span>Material;
<a name="l00264"></a>00264     <span class="keyword">class </span>MaterialPtr;
<a name="l00265"></a>00265     <span class="keyword">class </span>MaterialManager;
<a name="l00266"></a>00266     <span class="keyword">class </span>MaterialScriptCompiler;
<a name="l00267"></a>00267     <span class="keyword">class </span>Math;
<a name="l00268"></a>00268     <span class="keyword">class </span>Matrix3;
<a name="l00269"></a>00269     <span class="keyword">class </span>Matrix4;
<a name="l00270"></a>00270     <span class="keyword">class </span>MemoryManager;
<a name="l00271"></a>00271     <span class="keyword">class </span>Mesh;
<a name="l00272"></a>00272     <span class="keyword">class </span>MeshPtr;
<a name="l00273"></a>00273     <span class="keyword">class </span>MeshSerializer;
<a name="l00274"></a>00274     <span class="keyword">class </span>MeshSerializerImpl;
<a name="l00275"></a>00275     <span class="keyword">class </span>MeshManager;
<a name="l00276"></a>00276     <span class="keyword">class </span>MovableObject;
<a name="l00277"></a>00277     <span class="keyword">class </span>MovablePlane;
<a name="l00278"></a>00278     <span class="keyword">class </span>Node;
<a name="l00279"></a>00279     <span class="keyword">class </span>NodeAnimationTrack;
<a name="l00280"></a>00280     <span class="keyword">class </span>NodeKeyFrame;
<a name="l00281"></a>00281     <span class="keyword">class </span>NumericAnimationTrack;
<a name="l00282"></a>00282     <span class="keyword">class </span>NumericKeyFrame;
<a name="l00283"></a>00283     <span class="keyword">class </span>Overlay;
<a name="l00284"></a>00284     <span class="keyword">class </span>OverlayContainer;
<a name="l00285"></a>00285     <span class="keyword">class </span>OverlayElement;
<a name="l00286"></a>00286     <span class="keyword">class </span>OverlayElementFactory;
<a name="l00287"></a>00287     <span class="keyword">class </span>OverlayManager;
<a name="l00288"></a>00288     <span class="keyword">class </span>Particle;
<a name="l00289"></a>00289     <span class="keyword">class </span>ParticleAffector;
<a name="l00290"></a>00290     <span class="keyword">class </span>ParticleAffectorFactory;
<a name="l00291"></a>00291     <span class="keyword">class </span>ParticleEmitter;
<a name="l00292"></a>00292     <span class="keyword">class </span>ParticleEmitterFactory;
<a name="l00293"></a>00293     <span class="keyword">class </span>ParticleSystem;
<a name="l00294"></a>00294     <span class="keyword">class </span>ParticleSystemManager;
<a name="l00295"></a>00295     <span class="keyword">class </span>ParticleSystemRenderer;
<a name="l00296"></a>00296     <span class="keyword">class </span>ParticleSystemRendererFactory;
<a name="l00297"></a>00297     <span class="keyword">class </span>ParticleVisualData;
<a name="l00298"></a>00298     <span class="keyword">class </span>Pass;
<a name="l00299"></a>00299     <span class="keyword">class </span>PatchMesh;
<a name="l00300"></a>00300     <span class="keyword">class </span>PixelBox;
<a name="l00301"></a>00301     <span class="keyword">class </span>Plane;
<a name="l00302"></a>00302     <span class="keyword">class </span>PlaneBoundedVolume;
<a name="l00303"></a>00303     <span class="keyword">class </span>Plugin;
<a name="l00304"></a>00304     <span class="keyword">class </span>Pose;
<a name="l00305"></a>00305     <span class="keyword">class </span>ProgressiveMesh;
<a name="l00306"></a>00306     <span class="keyword">class </span>Profile;
<a name="l00307"></a>00307     <span class="keyword">class </span>Profiler;
<a name="l00308"></a>00308     <span class="keyword">class </span>Quaternion;
<a name="l00309"></a>00309     <span class="keyword">class </span>Radian;
<a name="l00310"></a>00310     <span class="keyword">class </span>Ray;
<a name="l00311"></a>00311     <span class="keyword">class </span>RaySceneQuery;
<a name="l00312"></a>00312     <span class="keyword">class </span>RaySceneQueryListener;
<a name="l00313"></a>00313     <span class="keyword">class </span>Renderable;
<a name="l00314"></a>00314     <span class="keyword">class </span>RenderPriorityGroup;
<a name="l00315"></a>00315     <span class="keyword">class </span>RenderQueue;
<a name="l00316"></a>00316     <span class="keyword">class </span>RenderQueueGroup;
<a name="l00317"></a>00317     <span class="keyword">class </span>RenderQueueInvocation;
<a name="l00318"></a>00318     <span class="keyword">class </span>RenderQueueInvocationSequence;
<a name="l00319"></a>00319     <span class="keyword">class </span>RenderQueueListener;
<a name="l00320"></a>00320     <span class="keyword">class </span>RenderSystem;
<a name="l00321"></a>00321     <span class="keyword">class </span>RenderSystemCapabilities;
<a name="l00322"></a>00322     <span class="keyword">class </span>RenderTarget;
<a name="l00323"></a>00323     <span class="keyword">class </span>RenderTargetListener;
<a name="l00324"></a>00324     <span class="keyword">class </span>RenderTexture;
<a name="l00325"></a>00325     <span class="keyword">class </span>MultiRenderTarget;
<a name="l00326"></a>00326     <span class="keyword">class </span>RenderWindow;
<a name="l00327"></a>00327     <span class="keyword">class </span>RenderOperation;
<a name="l00328"></a>00328     <span class="keyword">class </span>Resource;
<a name="l00329"></a>00329     <span class="keyword">class </span>ResourceBackgroundQueue;
<a name="l00330"></a>00330     <span class="keyword">class </span>ResourceGroupManager;
<a name="l00331"></a>00331     <span class="keyword">class </span>ResourceManager;
<a name="l00332"></a>00332     <span class="keyword">class </span>RibbonTrail;
<a name="l00333"></a>00333     <span class="keyword">class </span>Root;
<a name="l00334"></a>00334     <span class="keyword">class </span>SceneManager;
<a name="l00335"></a>00335     <span class="keyword">class </span>SceneManagerEnumerator;
<a name="l00336"></a>00336     <span class="keyword">class </span>SceneNode;
<a name="l00337"></a>00337     <span class="keyword">class </span>SceneQuery;
<a name="l00338"></a>00338     <span class="keyword">class </span>SceneQueryListener;
<a name="l00339"></a>00339     <span class="keyword">class </span>ScriptLoader;
<a name="l00340"></a>00340     <span class="keyword">class </span>Serializer;
<a name="l00341"></a>00341     <span class="keyword">class </span>ShadowCaster;
<a name="l00342"></a>00342     <span class="keyword">class </span>ShadowRenderable;
<a name="l00343"></a>00343     <span class="keyword">class </span>ShadowTextureManager;
<a name="l00344"></a>00344     <span class="keyword">class </span>SimpleRenderable;
<a name="l00345"></a>00345     <span class="keyword">class </span>SimpleSpline;
<a name="l00346"></a>00346     <span class="keyword">class </span>Skeleton;
<a name="l00347"></a>00347     <span class="keyword">class </span>SkeletonPtr;
<a name="l00348"></a>00348     <span class="keyword">class </span>SkeletonInstance;
<a name="l00349"></a>00349     <span class="keyword">class </span>SkeletonManager;
<a name="l00350"></a>00350     <span class="keyword">class </span>Sphere;
<a name="l00351"></a>00351     <span class="keyword">class </span>SphereSceneQuery;
<a name="l00352"></a>00352     <span class="keyword">class </span>StaticGeometry;
<a name="l00353"></a>00353     <span class="keyword">class </span>StringConverter;
<a name="l00354"></a>00354     <span class="keyword">class </span>StringInterface;
<a name="l00355"></a>00355     <span class="keyword">class </span>SubEntity;
<a name="l00356"></a>00356     <span class="keyword">class </span>SubMesh;
<a name="l00357"></a>00357     <span class="keyword">class </span>TagPoint;
<a name="l00358"></a>00358     <span class="keyword">class </span>Technique;
<a name="l00359"></a>00359     <span class="keyword">class </span>TempBlendedBufferInfo;
<a name="l00360"></a>00360     <span class="keyword">class </span>ExternalTextureSource;
<a name="l00361"></a>00361     <span class="keyword">class </span>TextureUnitState;
<a name="l00362"></a>00362     <span class="keyword">class </span>Texture;
<a name="l00363"></a>00363     <span class="keyword">class </span>TexturePtr;
<a name="l00364"></a>00364     <span class="keyword">class </span>TextureFont;
<a name="l00365"></a>00365     <span class="keyword">class </span>TextureManager;
<a name="l00366"></a>00366     <span class="keyword">class </span>TransformKeyFrame;
<a name="l00367"></a>00367     <span class="keyword">class </span>Timer;
<a name="l00368"></a>00368     <span class="keyword">class </span>UserDefinedObject;
<a name="l00369"></a>00369     <span class="keyword">class </span>Vector2;
<a name="l00370"></a>00370     <span class="keyword">class </span>Vector3;
<a name="l00371"></a>00371     <span class="keyword">class </span>Vector4;
<a name="l00372"></a>00372     <span class="keyword">class </span>Viewport;
<a name="l00373"></a>00373     <span class="keyword">class </span>VertexAnimationTrack;
<a name="l00374"></a>00374     <span class="keyword">class </span>VertexBufferBinding;
<a name="l00375"></a>00375     <span class="keyword">class </span>VertexData;
<a name="l00376"></a>00376     <span class="keyword">class </span>VertexDeclaration;
<a name="l00377"></a>00377     <span class="keyword">class </span>VertexMorphKeyFrame;
<a name="l00378"></a>00378     <span class="keyword">class </span>WireBoundingBox;
<a name="l00379"></a>00379     <span class="keyword">class </span>Compositor;
<a name="l00380"></a>00380     <span class="keyword">class </span>CompositorManager;
<a name="l00381"></a>00381     <span class="keyword">class </span>CompositorChain;
<a name="l00382"></a>00382     <span class="keyword">class </span>CompositorInstance;
<a name="l00383"></a>00383     <span class="keyword">class </span>CompositionTechnique;
<a name="l00384"></a>00384     <span class="keyword">class </span>CompositionPass;
<a name="l00385"></a>00385     <span class="keyword">class </span>CompositionTargetPass;
<a name="l00386"></a>00386 }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="preprocessor">#endif // __OgrePrerequisites_H__</span>
<a name="l00389"></a>00389 <span class="preprocessor"></span>
<a name="l00390"></a>00390 
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
